local buffer = {}

function buffer.newCanvas( wd, ht )
	-- create an appropriate imagedata size
	local w ,h = gr.getWidth(), gr.getHeight()
	local wd = wd or w	-- if no size provided, use full screen size
	local ht = ht or h
	if wd > w then wd = h end	-- don't make canvas bigger than buffer
	if ht > h then ht = h end
	local image	= love.image.newImageData( wd, ht )
	return image
	end

function buffer.setCanvas( name )
	if name then
		-- prepare to draw to canvas
		-- save present screen
			buffer.image	= gr.newImage( gr.newScreenshot() )
			buffer.color	= { love.graphics.getBackgroundColor() }
			buffer.name 	= name
		-- get size of canvas & save
			buffer.width	= name:getWidth()
			buffer.height	= name:getHeight()
		-- remove anything in buffer before new drawing
			gr.clear()
		-- OK, can now draw to buffer
		else
		------------------------------------------
		-- Drawing complete & ready to continue --
		------------------------------------------
		-- limit portion of screen buffer to save
			local wd	= buffer.width
			local ht	= buffer.height
		-- transfer only portion of buffer to canvas
			buffer.name:paste( gr.newScreenshot(), 0, 0, 0, 0, wd, ht )
		-- convert this portion of buffer to image
		local ig	= gr.newImage( buffer.name )
		-- return simulated canvas (actually an image)
		gr.setBackgroundColor( buffer.color )
		gr.clear()
		gr.draw(buffer.image)
		return ig
		end
	end

return buffer
